﻿-- Nightflyer Gilneas (EU)

ProfTimerData = { };
ProfTimerPlayerName = UnitName("player");
ProfTimerRealmName = GetRealmName();
ProfTimerProf = 0 ;
ProfTimerPlayerID = 0;
ProfTimerDebug= 0;
ProfTimerSPELLCAST_START =0;
ProfTimerSPELLCAST_ARG1 = "";
ProfTimer_elapsed = 0;
ProfTimer_Skill3_cast = 0;
ProfTimer_skill_elapsed = 0;

function ProfTimer_OnLoad() 
  
	

  	if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage( ProfTimer_SLoaded ); end;

	SlashCmdList["ProfTimer"] = ProfTimer_slash;
	SLASH_ProfTimer1 = "/ProfTimer";
	SLASH_ProfTimer2 = "/ProfT";
    
    if ( not ProfTimerData ) then ProfTimerData = {}; end;
    if ( not ProfTimerData.users ) then ProfTimerData.users = {}; end;
    
    this:RegisterEvent("TRADE_SKILL_UPDATE");
    this:RegisterEvent("PLAYER_ENTERING_WORLD");
    this:RegisterEvent("PLAYER_ALIVE");
    this:RegisterEvent("TRADE_SKILL_SHOW");
	this:RegisterEvent("SPELLCAST_START");
	this:RegisterEvent("SPELLCAST_STOP");

end 



function ProfTimer_OnEvent(event)
	if (not event) then return; end;
	if (event == "TRADE_SKILL_UPDATE" ) then
		ProfTimer_safecooldown() ;
    elseif (event == "PLAYER_ENTERING_WORLD" ) then
        ProfTimer_checkProf() ;
        ProfTimer_safecooldown() ;
        ProfTimer_actualcooldown(0) ;
    elseif (event == "PLAYER_ALIVE" ) then
        ProfTimer_checkProf() ;
    elseif (event == "TRADE_SKILL_SHOW" ) then
         ProfTimer_actualcooldown(0) ;
    elseif (event == "SPELLCAST_START" ) then
	    ProfTimerSPELLCAST_START = 1;
	    ProfTimerSPELLCAST_ARG1 = arg1;

    elseif (event == "SPELLCAST_STOP" ) then
	if ( ProfTimerSPELLCAST_START == 1) then
		--if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage("succesfully casted "..ProfTimerSPELLCAST_ARG1); end;
		if (string.find(ProfTimerSPELLCAST_ARG1 , ProfTimer_Skill3)) then
			if ( ProfTimerData.users[ProfTimerPlayerID].leath > 0) then
				ProfTimer_Skill3_cast = 1;
				ProfTimer_skill_elapsed = 0;
    				--ProfTimer_getcooldownLeath(ProfTimer_Prof3, ProfTimer_Skill3, 3, 1)
    			end
		
		end
		
	end
	ProfTimerSPELLCAST_START =0;



	else
		DEFAULT_CHAT_FRAME:AddMessage("ProfTimer Unknown event: "..event);
	end
end




function ProfTimer_slash() 
  

ProfTimer_actualcooldown(0) ;
	
end 








function ProfTimer_checkProf() 
	--checks if the current player has an Profession for Proftimer
	local i, j, alch, tail, leath;
	alch = 0;
    tail = 0;
    leath = 0;
    if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage("check Professions "); end;
    
	ExpandSkillHeader(0);
	for i=1, GetNumSkillLines(), 1 do
		local skillName, header, _, skillRank, _, _, _, _, _, _, _, _ = GetSkillLineInfo(i);
		-- check for the skill name
        --if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage("Prof "..skillName); end;
		if (skillName == ProfTimer_Prof1) then
				alch = skillRank;
				if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage("Alchemist "..alch); end;
				ProfTimerProf = 1;
		elseif (skillName == ProfTimer_Prof2) then
				tail = skillRank;
				if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage("Tailor "..tail); end;
				ProfTimerProf =1;
		elseif (skillName == ProfTimer_Prof3) then
				leath = skillRank;
				if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage("Leatherworking "..leath); end;
				ProfTimerProf =1;
			
		end
	end

	if ( ProfTimerProf == 1 )then
		ProfTimerPlayerID = ProfTimer_getPlayerID(ProfTimerPlayerName, ProfTimerRealmName);
		if ( ProfTimerPlayerID ==0 ) then
			ProfTimerPlayerID = ProfTimer_newPlayerID(ProfTimerPlayerName, ProfTimerRealmName);

		end
		

		ProfTimerData.users[ProfTimerPlayerID].alch = alch;
		ProfTimerData.users[ProfTimerPlayerID].tail = tail;
		ProfTimerData.users[ProfTimerPlayerID].leath = leath;
	else
		if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage("no profession found"); end;
		-- Delete Player entry Alex_todo	

	end

end


function ProfTimer_getPlayerID(Player, Realm)
	--gets the PlayerID
	local i, PlayerID;
    PlayerID = 0;
    if ( not ProfTimerData ) then ProfTimerData = {}; end;
    if ( not ProfTimerData.users ) then ProfTimerData.users = {}; end;
    if ( not ProfTimerData.NrUsers ) then ProfTimerData.NrUsers = 0; end;
    if ( ProfTimerData.users[1] ) then
	    for i=1, ProfTimerData.NrUsers, 1 do
		    if (ProfTimerData.users[i].Player == Player) then
                if (ProfTimerData.users[i].Realm == Realm) then
                  	PlayerID = i;
		    	    if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage("Player found "..PlayerID); end;
			        break;
                end    
		    end
        end    
	end
	return PlayerID;
		
end

function ProfTimer_newPlayerID(Player, Realm)
	--generates new Player
	local PlayerID = 0;
    if ( ProfTimerData.users[1] ) then
	    PlayerID = ProfTimerData.NrUsers + 1 ;
    else
        PlayerID =  1 ;
    end
	ProfTimerData.users[PlayerID] = { };
	ProfTimerData.users[PlayerID].Player = Player;
	ProfTimerData.users[PlayerID].Realm = Realm;
	ProfTimerData.users[PlayerID].ProfID = { };
    ProfTimerData.NrUsers = PlayerID;
	if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage("New Player "..PlayerID); end;

	return PlayerID;

end

function ProfTimer_safecooldown()
if ( ProfTimerProf == 1 )then    
    if ( ProfTimerData.users[ProfTimerPlayerID].alch > 0) then
        ProfTimer_getcooldown(ProfTimer_Prof1, ProfTimer_Skill1, 1)
    end
    if ( ProfTimerData.users[ProfTimerPlayerID].tail > 0) then
    	ProfTimer_getcooldown(ProfTimer_Prof2, ProfTimer_Skill2, 2)
    end
    if ( ProfTimerData.users[ProfTimerPlayerID].leath > 0) then
    	ProfTimer_getcooldownLeath(ProfTimer_Prof3, ProfTimer_Skill3, 3, 0)
    end


end
end


function ProfTimer_getcooldown(Prof, Skill, ProfID)
    local cooldown, SkillID, i, skillName ;
	--CastSpellByName ( Prof );
    	--CloseTradeSkill();
	
	
	for i = 1, GetNumTradeSkills() do
		skillName, _, _, _ = GetTradeSkillInfo(i);
        --if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage("Prof "..skillName); end;
		if (skillName == Skill) then
			SkillID = i;
			cooldown = (GetTradeSkillCooldown(SkillID));
				if ( not ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID] ) then ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID] = {}; end;
			    	ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID].yday = date("%j");
				ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID].hour = date("%H");
    				ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID].min  = date("%M");
    				ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID].sec  = date("%S");
                    ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID].Prof  = Prof;
				if ( cooldown == nil ) then
        				cooldown = 0;
    				end
				ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID].cooldown = cooldown;
                if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage("cooldown saved: "..cooldown); end;
			break;
		end
		if i == GetNumTradeSkills() then
			
				if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage("Profession not found: "..Skill); end;
		end
	end
   
  
end

function ProfTimer_actualcooldown(callID)
	local i, PTdiffTime ;
	if ( ProfTimerData.NrUsers ) then 
	for i=1, ProfTimerData.NrUsers do
		if ( ProfTimerData.users[i].alch > 0) then
			if ProfTimerData.users[i].ProfID[1] then
				PTdiffTime = ProfTimer_diffTime(i, 1);
				ProfTimer_outputdiffTime(i, 1, PTdiffTime,callID);
			end
		end		
		if ( ProfTimerData.users[i].tail > 0) then
			if ProfTimerData.users[i].ProfID[2] then
				PTdiffTime = ProfTimer_diffTime(i, 2);
				ProfTimer_outputdiffTime(i, 2, PTdiffTime,callID);
			end
		end
		if ( ProfTimerData.users[i].leath > 0) then
			if ProfTimerData.users[i].ProfID[3] then
				PTdiffTime = ProfTimer_diffTime(i, 3);
				ProfTimer_outputdiffTime(i, 3, PTdiffTime,callID);
			end
		end

	end
    end

end

function ProfTimer_diffTime(user, ProfID)

	local PTdifftime, i ;
	i = date("%j") - ProfTimerData.users[user].ProfID[ProfID].yday ;
	if (i < 0 ) then 
		i= i + 365;
	end
	PTdifftime = i * 86400 ;
	i = date("%H") - ProfTimerData.users[user].ProfID[ProfID].hour ;
	if (i < 0 ) then 
		i= i + 24;
        PTdifftime = PTdifftime - 86400 ; 
	end
	PTdifftime = i * 3600 + PTdifftime ;
	i = date("%M") - ProfTimerData.users[user].ProfID[ProfID].min ;
	if (i < 0 ) then 
		i= i + 60;
        PTdifftime = PTdifftime - 3600 ; 
	end
	PTdifftime = i * 60 + PTdifftime ;
	i = date("%S") - ProfTimerData.users[user].ProfID[ProfID].sec ;
	if (i < 0 ) then 
		i= i + 60;
        PTdifftime = PTdifftime - 60 ; 
	end
	PTdifftime = i + PTdifftime ;
	PTdifftime = ProfTimerData.users[user].ProfID[ProfID].cooldown - PTdifftime ;

	return PTdifftime;

end

function ProfTimer_outputdiffTime(user, ProfID, PTdifftime,callID)

	local day, hour, min, i;
	local warn = 0;
	if ( not ProfTimerData.users[user].ProfID[ProfID].warnID ) then ProfTimerData.users[user].ProfID[ProfID].warnID = 0; end;
	if ( PTdifftime > 1800 ) then 
		ProfTimerData.users[user].ProfID[ProfID].warnID = 0;
	elseif ( (PTdifftime > 0 ) and ( ProfTimerData.users[user].ProfID[ProfID].warnID == 0)) then
		ProfTimerData.users[user].ProfID[ProfID].warnID = 1;
		warn = 1;
	elseif ( (PTdifftime > 0 ) and ( ProfTimerData.users[user].ProfID[ProfID].warnID == 2)) then
		ProfTimerData.users[user].ProfID[ProfID].warnID = 1;
	elseif ( (PTdifftime < 0 ) and ( ProfTimerData.users[user].ProfID[ProfID].warnID < 2)) then
		ProfTimerData.users[user].ProfID[ProfID].warnID = 2;
		warn = 1;	
	end

	if ((warn == 1) or (callID == 0)) then
    if ( not ProfTimerData.users[user].ProfID[ProfID].Prof ) then ProfTimerData.users[user].ProfID[ProfID].Prof = "?"; end;
	if ( PTdifftime > 0) then 
		day = math.floor( PTdifftime / 86400 );
		i= ( PTdifftime - (day * 86400 ));
		hour = math.floor( i / 3600 );
		i = (i- (hour * 3600 ));
		min = math.floor(i / 60 );
		sec = math.floor(i - (min *60 ));
		if ( PTdifftime > 1800 ) then 
			DEFAULT_CHAT_FRAME:AddMessage("<ProfTimer> "..ProfTimerData.users[user].Realm .." : "..ProfTimerData.users[user].Player.." : "..ProfTimerData.users[user].ProfID[ProfID].Prof..ProfTimer_readyin..day.." D "..hour.." h "..min.." m "..sec.." s"  , 0 , 1.0 , 0  );	
		else
			DEFAULT_CHAT_FRAME:AddMessage("<ProfTimer> "..ProfTimerData.users[user].Realm .." : "..ProfTimerData.users[user].Player.." : "..ProfTimerData.users[user].ProfID[ProfID].Prof..ProfTimer_readyin..day.." D "..hour.." h "..min.." m "..sec.." s"  , 1.0 , 1.0 , 0  );	
		end
	else
		    DEFAULT_CHAT_FRAME:AddMessage("<ProfTimer> "..ProfTimerData.users[user].Realm .." : "..ProfTimerData.users[user].Player.." : "..ProfTimerData.users[user].ProfID[ProfID].Prof..ProfTimer_ready  , 1.0 , 0 , 0  );	

	end

	end

end

function ProfTimer_getcooldownLeath(Prof, Skill, ProfID, callID)
	local bag, slot, startTime, duration, isEnabled, inbag;
	inbag =0;

	for bag=0,4 do
    		for slot=1,GetContainerNumSlots(bag) do
      			if (GetContainerItemLink(bag,slot)) then
        			if (string.find(GetContainerItemLink(bag,slot), ProfTimer_Skill3)) then
					inbag =1;
          				if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage(ProfTimer_Skill3.." found "..bag..","..slot); end;
					startTime, duration, isEnabled = GetContainerItemCooldown(bag, slot);
                   			if ( duration == nil ) then
        					duration = 0;
    					end
                    
					if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage(startTime.." start "..duration.." duration "..isEnabled ); end;
        								

                    		end
      			end
    		end
  	end

	if ( inbag == 1) then
		if ( ((callID == 0) and (duration ==0)) or (callID ==1)) then
            if ( not ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID] ) then ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID] = {}; end;
			ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID].yday = date("%j");
			ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID].hour = date("%H");
    			ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID].min  = date("%M");
    			ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID].sec  = date("%S");			
			ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID].cooldown = duration;
            ProfTimerData.users[ProfTimerPlayerID].ProfID[ProfID].Prof  = Prof;
			if (ProfTimerDebug == 1) then DEFAULT_CHAT_FRAME:AddMessage(" leather time saved "..duration); end;
		end
	end

end


function ProfTimer_OnUpdate( elapsed )
	ProfTimer_elapsed = ProfTimer_elapsed + elapsed;
	
	if( ProfTimer_elapsed > 60 ) then
				      
		ProfTimer_actualcooldown(1) ;

		ProfTimer_elapsed = 0;
	end
	if (ProfTimer_Skill3_cast == 1) then
		ProfTimer_skill_elapsed = ProfTimer_skill_elapsed + elapsed;
		if( ProfTimer_elapsed > 0.7 ) then
			ProfTimer_Skill3_cast = 0;
			ProfTimer_skill_elapsed = 0;
    			ProfTimer_getcooldownLeath(ProfTimer_Prof3, ProfTimer_Skill3, 3, 1)
		
		end	

	end
end